# unitycatalog-client-preview
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1
- Package version: 1.0.0
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonPydanticV1ClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import unitycatalog_client_preview
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import unitycatalog_client_preview
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
import unitycatalog_client_preview
from unitycatalog_client_preview.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost:8080/api/2.1/unity-catalog
# See configuration.py for a list of all supported configuration parameters.
configuration = unitycatalog_client_preview.Configuration(
    host = "http://localhost:8080/api/2.1/unity-catalog"
)



# Enter a context with an instance of the API client
with unitycatalog_client_preview.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = unitycatalog_client_preview.CatalogsApi(api_client)
    create_catalog = unitycatalog_client_preview.CreateCatalog() # CreateCatalog |  (optional)

    try:
        # Create a catalog
        api_response = api_instance.create_catalog(create_catalog=create_catalog)
        print("The response of CatalogsApi->create_catalog:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling CatalogsApi->create_catalog: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8080/api/2.1/unity-catalog*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CatalogsApi* | [**create_catalog**](docs/CatalogsApi.md#create_catalog) | **POST** /catalogs | Create a catalog
*CatalogsApi* | [**delete_catalog**](docs/CatalogsApi.md#delete_catalog) | **DELETE** /catalogs/{name} | Delete a catalog
*CatalogsApi* | [**get_catalog**](docs/CatalogsApi.md#get_catalog) | **GET** /catalogs/{name} | Get a catalog
*CatalogsApi* | [**list_catalogs**](docs/CatalogsApi.md#list_catalogs) | **GET** /catalogs | List catalogs
*CatalogsApi* | [**update_catalog**](docs/CatalogsApi.md#update_catalog) | **PATCH** /catalogs/{name} | Update a catalog
*FunctionsApi* | [**create_function**](docs/FunctionsApi.md#create_function) | **POST** /functions | Create a function. WARNING: This API is experimental and will change in future versions. 
*FunctionsApi* | [**delete_function**](docs/FunctionsApi.md#delete_function) | **DELETE** /functions/{name} | Delete a function
*FunctionsApi* | [**get_function**](docs/FunctionsApi.md#get_function) | **GET** /functions/{name} | Get a function
*FunctionsApi* | [**list_functions**](docs/FunctionsApi.md#list_functions) | **GET** /functions | List functions
*GrantsApi* | [**get**](docs/GrantsApi.md#get) | **GET** /permissions/{securable_type}/{full_name} | Get permissions
*GrantsApi* | [**update**](docs/GrantsApi.md#update) | **PATCH** /permissions/{securable_type}/{full_name} | Update a permission
*ModelVersionsApi* | [**create_model_version**](docs/ModelVersionsApi.md#create_model_version) | **POST** /models/versions | Create a model version. 
*ModelVersionsApi* | [**delete_model_version**](docs/ModelVersionsApi.md#delete_model_version) | **DELETE** /models/{full_name}/versions/{version} | Delete a model version
*ModelVersionsApi* | [**finalize_model_version**](docs/ModelVersionsApi.md#finalize_model_version) | **PATCH** /models/{full_name}/versions/{version}/finalize | Finalize a model version
*ModelVersionsApi* | [**get_model_version**](docs/ModelVersionsApi.md#get_model_version) | **GET** /models/{full_name}/versions/{version} | Get a model version
*ModelVersionsApi* | [**list_model_versions**](docs/ModelVersionsApi.md#list_model_versions) | **GET** /models/{full_name}/versions | List model versions of the specified registered model.
*ModelVersionsApi* | [**update_model_version**](docs/ModelVersionsApi.md#update_model_version) | **PATCH** /models/{full_name}/versions/{version} | Update a model version
*RegisteredModelsApi* | [**create_registered_model**](docs/RegisteredModelsApi.md#create_registered_model) | **POST** /models | Create a model. WARNING: This API is experimental and will change in future versions. 
*RegisteredModelsApi* | [**delete_registered_model**](docs/RegisteredModelsApi.md#delete_registered_model) | **DELETE** /models/{full_name} | Delete a specified registered model.
*RegisteredModelsApi* | [**get_registered_model**](docs/RegisteredModelsApi.md#get_registered_model) | **GET** /models/{full_name} | Get a specified registered model
*RegisteredModelsApi* | [**list_registered_models**](docs/RegisteredModelsApi.md#list_registered_models) | **GET** /models | List models
*RegisteredModelsApi* | [**update_registered_model**](docs/RegisteredModelsApi.md#update_registered_model) | **PATCH** /models/{full_name} | Update a registered model
*SchemasApi* | [**create_schema**](docs/SchemasApi.md#create_schema) | **POST** /schemas | Create a schema
*SchemasApi* | [**delete_schema**](docs/SchemasApi.md#delete_schema) | **DELETE** /schemas/{full_name} | Delete a schema
*SchemasApi* | [**get_schema**](docs/SchemasApi.md#get_schema) | **GET** /schemas/{full_name} | Get a schema
*SchemasApi* | [**list_schemas**](docs/SchemasApi.md#list_schemas) | **GET** /schemas | List schemas
*SchemasApi* | [**update_schema**](docs/SchemasApi.md#update_schema) | **PATCH** /schemas/{full_name} | Update a schema
*TablesApi* | [**create_table**](docs/TablesApi.md#create_table) | **POST** /tables | Create a table. Only external table creation is supported. WARNING: This API is experimental and will change in future versions. 
*TablesApi* | [**delete_table**](docs/TablesApi.md#delete_table) | **DELETE** /tables/{full_name} | Delete a table
*TablesApi* | [**get_table**](docs/TablesApi.md#get_table) | **GET** /tables/{full_name} | Get a table
*TablesApi* | [**list_tables**](docs/TablesApi.md#list_tables) | **GET** /tables | List tables
*TemporaryCredentialsApi* | [**generate_temporary_model_version_credentials**](docs/TemporaryCredentialsApi.md#generate_temporary_model_version_credentials) | **POST** /temporary-model-version-credentials | Generate temporary model version credentials. These credentials are used by clients to write and retrieve model artifacts from the model versions external storage location.
*TemporaryCredentialsApi* | [**generate_temporary_path_credentials**](docs/TemporaryCredentialsApi.md#generate_temporary_path_credentials) | **POST** /temporary-path-credentials | Generate temporary path credentials.
*TemporaryCredentialsApi* | [**generate_temporary_table_credentials**](docs/TemporaryCredentialsApi.md#generate_temporary_table_credentials) | **POST** /temporary-table-credentials | Generate temporary table credentials.
*TemporaryCredentialsApi* | [**generate_temporary_volume_credentials**](docs/TemporaryCredentialsApi.md#generate_temporary_volume_credentials) | **POST** /temporary-volume-credentials | Generate temporary volume credentials.
*VolumesApi* | [**create_volume**](docs/VolumesApi.md#create_volume) | **POST** /volumes | Create a Volume
*VolumesApi* | [**delete_volume**](docs/VolumesApi.md#delete_volume) | **DELETE** /volumes/{name} | Delete a Volume
*VolumesApi* | [**get_volume**](docs/VolumesApi.md#get_volume) | **GET** /volumes/{name} | Get a Volume
*VolumesApi* | [**list_volumes**](docs/VolumesApi.md#list_volumes) | **GET** /volumes | List Volumes
*VolumesApi* | [**update_volume**](docs/VolumesApi.md#update_volume) | **PATCH** /volumes/{name} | Update a Volume


## Documentation For Models

 - [AwsCredentials](docs/AwsCredentials.md)
 - [AzureUserDelegationSAS](docs/AzureUserDelegationSAS.md)
 - [CatalogInfo](docs/CatalogInfo.md)
 - [ColumnInfo](docs/ColumnInfo.md)
 - [ColumnTypeName](docs/ColumnTypeName.md)
 - [CreateCatalog](docs/CreateCatalog.md)
 - [CreateFunction](docs/CreateFunction.md)
 - [CreateFunctionRequest](docs/CreateFunctionRequest.md)
 - [CreateModelVersion](docs/CreateModelVersion.md)
 - [CreateRegisteredModel](docs/CreateRegisteredModel.md)
 - [CreateSchema](docs/CreateSchema.md)
 - [CreateTable](docs/CreateTable.md)
 - [CreateVolumeRequestContent](docs/CreateVolumeRequestContent.md)
 - [DataSourceFormat](docs/DataSourceFormat.md)
 - [Dependency](docs/Dependency.md)
 - [DependencyList](docs/DependencyList.md)
 - [FinalizeModelVersion](docs/FinalizeModelVersion.md)
 - [FunctionDependency](docs/FunctionDependency.md)
 - [FunctionInfo](docs/FunctionInfo.md)
 - [FunctionParameterInfo](docs/FunctionParameterInfo.md)
 - [FunctionParameterInfos](docs/FunctionParameterInfos.md)
 - [FunctionParameterMode](docs/FunctionParameterMode.md)
 - [FunctionParameterType](docs/FunctionParameterType.md)
 - [GcpOauthToken](docs/GcpOauthToken.md)
 - [GenerateTemporaryModelVersionCredential](docs/GenerateTemporaryModelVersionCredential.md)
 - [GenerateTemporaryPathCredential](docs/GenerateTemporaryPathCredential.md)
 - [GenerateTemporaryTableCredential](docs/GenerateTemporaryTableCredential.md)
 - [GenerateTemporaryVolumeCredential](docs/GenerateTemporaryVolumeCredential.md)
 - [ListCatalogsResponse](docs/ListCatalogsResponse.md)
 - [ListFunctionsResponse](docs/ListFunctionsResponse.md)
 - [ListModelVersionsResponse](docs/ListModelVersionsResponse.md)
 - [ListRegisteredModelsResponse](docs/ListRegisteredModelsResponse.md)
 - [ListSchemasResponse](docs/ListSchemasResponse.md)
 - [ListTablesResponse](docs/ListTablesResponse.md)
 - [ListVolumesResponseContent](docs/ListVolumesResponseContent.md)
 - [ModelVersionInfo](docs/ModelVersionInfo.md)
 - [ModelVersionOperation](docs/ModelVersionOperation.md)
 - [ModelVersionStatus](docs/ModelVersionStatus.md)
 - [PathOperation](docs/PathOperation.md)
 - [PermissionsChange](docs/PermissionsChange.md)
 - [PermissionsList](docs/PermissionsList.md)
 - [PrincipalType](docs/PrincipalType.md)
 - [Privilege](docs/Privilege.md)
 - [PrivilegeAssignment](docs/PrivilegeAssignment.md)
 - [RegisteredModelInfo](docs/RegisteredModelInfo.md)
 - [SchemaInfo](docs/SchemaInfo.md)
 - [SecurableType](docs/SecurableType.md)
 - [TableDependency](docs/TableDependency.md)
 - [TableInfo](docs/TableInfo.md)
 - [TableOperation](docs/TableOperation.md)
 - [TableType](docs/TableType.md)
 - [TemporaryCredentials](docs/TemporaryCredentials.md)
 - [UpdateCatalog](docs/UpdateCatalog.md)
 - [UpdateModelVersion](docs/UpdateModelVersion.md)
 - [UpdatePermissions](docs/UpdatePermissions.md)
 - [UpdateRegisteredModel](docs/UpdateRegisteredModel.md)
 - [UpdateSchema](docs/UpdateSchema.md)
 - [UpdateVolumeRequestContent](docs/UpdateVolumeRequestContent.md)
 - [VolumeInfo](docs/VolumeInfo.md)
 - [VolumeOperation](docs/VolumeOperation.md)
 - [VolumeType](docs/VolumeType.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




