# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError

from typing_extensions import Annotated
from pydantic import Field, StrictStr

from typing import Optional

from unitycatalog_client_preview.models.permissions_list import PermissionsList
from unitycatalog_client_preview.models.securable_type import SecurableType
from unitycatalog_client_preview.models.update_permissions import UpdatePermissions

from unitycatalog_client_preview.api_client import ApiClient
from unitycatalog_client_preview.api_response import ApiResponse
from unitycatalog_client_preview.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class GrantsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def get(self, securable_type : Annotated[SecurableType, Field(..., description="Type of securable.")], full_name : Annotated[StrictStr, Field(..., description="Full name of securable.")], principal : Annotated[Optional[StrictStr], Field(description="If provided, only the permissions for the specified principal (user or group) are returned. ")] = None, **kwargs) -> PermissionsList:  # noqa: E501
        """Get permissions  # noqa: E501

        Gets the permissions for a securable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get(securable_type, full_name, principal, async_req=True)
        >>> result = thread.get()

        :param securable_type: Type of securable. (required)
        :type securable_type: SecurableType
        :param full_name: Full name of securable. (required)
        :type full_name: str
        :param principal: If provided, only the permissions for the specified principal (user or group) are returned. 
        :type principal: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PermissionsList
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.get_with_http_info(securable_type, full_name, principal, **kwargs)  # noqa: E501

    @validate_arguments
    def get_with_http_info(self, securable_type : Annotated[SecurableType, Field(..., description="Type of securable.")], full_name : Annotated[StrictStr, Field(..., description="Full name of securable.")], principal : Annotated[Optional[StrictStr], Field(description="If provided, only the permissions for the specified principal (user or group) are returned. ")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Get permissions  # noqa: E501

        Gets the permissions for a securable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_with_http_info(securable_type, full_name, principal, async_req=True)
        >>> result = thread.get()

        :param securable_type: Type of securable. (required)
        :type securable_type: SecurableType
        :param full_name: Full name of securable. (required)
        :type full_name: str
        :param principal: If provided, only the permissions for the specified principal (user or group) are returned. 
        :type principal: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PermissionsList, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'securable_type',
            'full_name',
            'principal'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['securable_type'] is not None:
            _path_params['securable_type'] = _params['securable_type']

        if _params['full_name'] is not None:
            _path_params['full_name'] = _params['full_name']


        # process the query parameters
        _query_params = []
        if _params.get('principal') is not None:  # noqa: E501
            _query_params.append(('principal', _params['principal']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "PermissionsList",
        }

        return self.api_client.call_api(
            '/permissions/{securable_type}/{full_name}', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def update(self, securable_type : Annotated[SecurableType, Field(..., description="Type of securable.")], full_name : Annotated[StrictStr, Field(..., description="Full name of securable.")], update_permissions : Optional[UpdatePermissions] = None, **kwargs) -> PermissionsList:  # noqa: E501
        """Update a permission  # noqa: E501

        Updates the permissions for a securable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update(securable_type, full_name, update_permissions, async_req=True)
        >>> result = thread.get()

        :param securable_type: Type of securable. (required)
        :type securable_type: SecurableType
        :param full_name: Full name of securable. (required)
        :type full_name: str
        :param update_permissions:
        :type update_permissions: UpdatePermissions
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PermissionsList
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the update_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        return self.update_with_http_info(securable_type, full_name, update_permissions, **kwargs)  # noqa: E501

    @validate_arguments
    def update_with_http_info(self, securable_type : Annotated[SecurableType, Field(..., description="Type of securable.")], full_name : Annotated[StrictStr, Field(..., description="Full name of securable.")], update_permissions : Optional[UpdatePermissions] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Update a permission  # noqa: E501

        Updates the permissions for a securable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_with_http_info(securable_type, full_name, update_permissions, async_req=True)
        >>> result = thread.get()

        :param securable_type: Type of securable. (required)
        :type securable_type: SecurableType
        :param full_name: Full name of securable. (required)
        :type full_name: str
        :param update_permissions:
        :type update_permissions: UpdatePermissions
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PermissionsList, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'securable_type',
            'full_name',
            'update_permissions'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['securable_type'] is not None:
            _path_params['securable_type'] = _params['securable_type']

        if _params['full_name'] is not None:
            _path_params['full_name'] = _params['full_name']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['update_permissions'] is not None:
            _body_params = _params['update_permissions']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = []  # noqa: E501

        _response_types_map = {
            '200': "PermissionsList",
        }

        return self.api_client.call_api(
            '/permissions/{securable_type}/{full_name}', 'PATCH',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
