# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class CatalogInfo(BaseModel):
    """
    CatalogInfo
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of catalog.")
    comment: Optional[StrictStr] = Field(default=None, description="User-provided free-form text description.")
    properties: Optional[Dict[str, StrictStr]] = Field(default=None, description="A map of key-value properties attached to the securable.")
    owner: Optional[StrictStr] = Field(default=None, description="Username of current owner of catalog.")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this catalog was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="Username of catalog creator.")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which this catalog was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="Username of user who last modified catalog.")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the catalog.")
    __properties = ["name", "comment", "properties", "owner", "created_at", "created_by", "updated_at", "updated_by", "id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CatalogInfo:
        """Create an instance of CatalogInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CatalogInfo:
        """Create an instance of CatalogInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return CatalogInfo.parse_obj(obj)

        _obj = CatalogInfo.parse_obj({
            "name": obj.get("name"),
            "comment": obj.get("comment"),
            "properties": obj.get("properties"),
            "owner": obj.get("owner"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "id": obj.get("id")
        })
        return _obj


