# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from unitycatalog_client_preview.models.column_type_name import ColumnTypeName
from unitycatalog_client_preview.models.function_parameter_mode import FunctionParameterMode
from unitycatalog_client_preview.models.function_parameter_type import FunctionParameterType

class FunctionParameterInfo(BaseModel):
    """
    FunctionParameterInfo
    """
    name: StrictStr = Field(default=..., description="Name of parameter.")
    type_text: StrictStr = Field(default=..., description="Full data type spec, SQL/catalogString text.")
    type_json: StrictStr = Field(default=..., description="Full data type spec, JSON-serialized.")
    type_name: ColumnTypeName = Field(...)
    type_precision: Optional[StrictInt] = Field(default=None, description="Digits of precision; required on Create for DecimalTypes.")
    type_scale: Optional[StrictInt] = Field(default=None, description="Digits to right of decimal; Required on Create for DecimalTypes.")
    type_interval_type: Optional[StrictStr] = Field(default=None, description="Format of IntervalType.")
    position: StrictInt = Field(default=..., description="Ordinal position of column (starting at position 0).")
    parameter_mode: Optional[FunctionParameterMode] = None
    parameter_type: Optional[FunctionParameterType] = None
    parameter_default: Optional[StrictStr] = Field(default=None, description="Default value of the parameter.")
    comment: Optional[StrictStr] = Field(default=None, description="User-provided free-form text description.")
    __properties = ["name", "type_text", "type_json", "type_name", "type_precision", "type_scale", "type_interval_type", "position", "parameter_mode", "parameter_type", "parameter_default", "comment"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FunctionParameterInfo:
        """Create an instance of FunctionParameterInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FunctionParameterInfo:
        """Create an instance of FunctionParameterInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FunctionParameterInfo.parse_obj(obj)

        _obj = FunctionParameterInfo.parse_obj({
            "name": obj.get("name"),
            "type_text": obj.get("type_text"),
            "type_json": obj.get("type_json"),
            "type_name": obj.get("type_name"),
            "type_precision": obj.get("type_precision"),
            "type_scale": obj.get("type_scale"),
            "type_interval_type": obj.get("type_interval_type"),
            "position": obj.get("position"),
            "parameter_mode": obj.get("parameter_mode"),
            "parameter_type": obj.get("parameter_type"),
            "parameter_default": obj.get("parameter_default"),
            "comment": obj.get("comment")
        })
        return _obj


