# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from unitycatalog_client_preview.models.model_version_status import ModelVersionStatus

class ModelVersionInfo(BaseModel):
    """
    ModelVersionInfo
    """
    model_name: Optional[StrictStr] = Field(default=None, description="The name of the parent registered model of the model version, relative to parent schema")
    catalog_name: Optional[StrictStr] = Field(default=None, description="The name of the catalog containing the model version")
    schema_name: Optional[StrictStr] = Field(default=None, description="The name of the schema containing the model version, relative to parent catalog")
    version: Optional[StrictInt] = Field(default=None, description="Integer model version number, used to reference the model version in API requests.")
    source: Optional[StrictStr] = Field(default=None, description="URI indicating the location of the source artifacts (files) for the model version")
    run_id: Optional[StrictStr] = Field(default=None, description="The run id used by the ML package that generated the model.")
    status: Optional[ModelVersionStatus] = None
    storage_location: Optional[StrictStr] = Field(default=None, description="The storage location on the cloud under which model version data files are stored")
    comment: Optional[StrictStr] = Field(default=None, description="The comment attached to the model version")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this model version was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="The identifier of the user who created the model version")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which this model version was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="The identifier of the user who updated the model version last time")
    id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the model version.")
    __properties = ["model_name", "catalog_name", "schema_name", "version", "source", "run_id", "status", "storage_location", "comment", "created_at", "created_by", "updated_at", "updated_by", "id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ModelVersionInfo:
        """Create an instance of ModelVersionInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ModelVersionInfo:
        """Create an instance of ModelVersionInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ModelVersionInfo.parse_obj(obj)

        _obj = ModelVersionInfo.parse_obj({
            "model_name": obj.get("model_name"),
            "catalog_name": obj.get("catalog_name"),
            "schema_name": obj.get("schema_name"),
            "version": obj.get("version"),
            "source": obj.get("source"),
            "run_id": obj.get("run_id"),
            "status": obj.get("status"),
            "storage_location": obj.get("storage_location"),
            "comment": obj.get("comment"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "id": obj.get("id")
        })
        return _obj


