# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class SchemaInfo(BaseModel):
    """
    SchemaInfo
    """
    name: Optional[StrictStr] = Field(default=None, description="Name of schema, relative to parent catalog.")
    catalog_name: Optional[StrictStr] = Field(default=None, description="Name of parent catalog.")
    comment: Optional[StrictStr] = Field(default=None, description="User-provided free-form text description.")
    properties: Optional[Dict[str, StrictStr]] = Field(default=None, description="A map of key-value properties attached to the securable.")
    full_name: Optional[StrictStr] = Field(default=None, description="Full name of schema, in form of __catalog_name__.__schema_name__.")
    owner: Optional[StrictStr] = Field(default=None, description="Username of current owner of schema.")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this schema was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="Username of schema creator.")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which this schema was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="Username of user who last modified schema.")
    schema_id: Optional[StrictStr] = Field(default=None, description="Unique identifier for the schema.")
    __properties = ["name", "catalog_name", "comment", "properties", "full_name", "owner", "created_at", "created_by", "updated_at", "updated_by", "schema_id"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SchemaInfo:
        """Create an instance of SchemaInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SchemaInfo:
        """Create an instance of SchemaInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SchemaInfo.parse_obj(obj)

        _obj = SchemaInfo.parse_obj({
            "name": obj.get("name"),
            "catalog_name": obj.get("catalog_name"),
            "comment": obj.get("comment"),
            "properties": obj.get("properties"),
            "full_name": obj.get("full_name"),
            "owner": obj.get("owner"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "schema_id": obj.get("schema_id")
        })
        return _obj


