# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, constr
from unitycatalog_client_preview.models.volume_type import VolumeType

class VolumeInfo(BaseModel):
    """
    VolumeInfo
    """
    catalog_name: Optional[StrictStr] = Field(default=None, description="The name of the catalog where the schema and the volume are")
    schema_name: Optional[StrictStr] = Field(default=None, description="The name of the schema where the volume is")
    name: Optional[StrictStr] = Field(default=None, description="The name of the volume")
    comment: Optional[constr(strict=True, max_length=65536, min_length=1)] = Field(default=None, description="The comment attached to the volume")
    owner: Optional[StrictStr] = Field(default=None, description="The identifier of the user who owns the volume")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this volume was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="TThe identifier of the user who created the volume")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which this volume was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="The identifier of the user who updated the volume last time")
    volume_id: Optional[StrictStr] = Field(default=None, description="Unique identifier of the volume")
    volume_type: Optional[VolumeType] = None
    storage_location: Optional[StrictStr] = Field(default=None, description="The storage location of the volume")
    full_name: Optional[StrictStr] = Field(default=None, description="Full name of volume, in form of __catalog_name__.__schema_name__.__volume_name__.")
    __properties = ["catalog_name", "schema_name", "name", "comment", "owner", "created_at", "created_by", "updated_at", "updated_by", "volume_id", "volume_type", "storage_location", "full_name"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> VolumeInfo:
        """Create an instance of VolumeInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> VolumeInfo:
        """Create an instance of VolumeInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return VolumeInfo.parse_obj(obj)

        _obj = VolumeInfo.parse_obj({
            "catalog_name": obj.get("catalog_name"),
            "schema_name": obj.get("schema_name"),
            "name": obj.get("name"),
            "comment": obj.get("comment"),
            "owner": obj.get("owner"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "volume_id": obj.get("volume_id"),
            "volume_type": obj.get("volume_type"),
            "storage_location": obj.get("storage_location"),
            "full_name": obj.get("full_name")
        })
        return _obj


